# RFlow-Components-AMQP

[![Build Status](https://travis-ci.org/redjack/rflow-components-amqp.png?branch=master)](https://travis-ci.org/redjack/rflow-components-amqp)

A gem containing AMQP-specific components and data types for RFlow
(https://github.com/redjack/rflow).

## Data Types

* `RFlow::Message::Data::AMQP::Message` - an AMQP message

## Subscriber

The subscriber component (`RFlow::Components::AMQP::Subscriber`)
implements a AMQP subscriber using the
[amqp gem](https://github.com/ruby-amqp/amqp) and operates as an RFlow
source (i.e. it does not have any input ports). The component connects
to an AMQP broker, establishes a (default transient) queue, and
registers a message binding pattern to accept deliver messages to the
queue, all based on the component configuration (which mirrors the
underlying amqp gem's configuration).

The subscriber uses two ports for sending messages, an `amqp_port`
(which sends `RFlow::Message::Data::AMQP::Message` messages) and a
`raw_port` (which sends relatively unstructured
`RFlow::Message::Data::Raw` messages).

### Configuration

* 'server' => '127.0.0.1'
* 'port' => 5672
* 'username' => 'guest'
* 'password' => 'guest'
* 'vhost' => '/'
* 'queue_name' => 'asdf'
* 'queue_passive' => false
* 'queue_durable' => false
* 'queue_exclusive' => true
* 'queue_auto_delete' => true
* 'binding_pattern' => ''

### Examples

### Limitations


## Publisher

Not yet implemented


## License

   Copyright 2014 RedJack LLC

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
