require 'spec_helper.rb'

describe 'RFlow::Message::Data::AMQP::Message Avro Schema' do
  let(:schema) { RFlow::Configuration.available_data_types['RFlow::Message::Data::AMQP::Message']['avro'] }

  it "should encode and decode an object" do
    message = {
      'header'  => {
        'content_type'  => 'application/octet-stream',
        'delivery_mode' => 2,
        'priority'      => 0,
      },
      'payload' =>'PAYLOAD',
    }

    expect { encode_avro(schema, message)}.to_not raise_error
    encoded_message = encode_avro(schema, message)

    expect { decode_avro(schema, encoded_message) }.to_not raise_error
    decoded_message = decode_avro(schema, encoded_message)

    expect(decoded_message['payload']).to eq(message['payload'])
    expect(decoded_message['header']).to eq(message['header'])
  end
end
